mod datastore;
use tokio::task::JoinSet;
mod grpc;
mod http_server;
use crate::datastore::Store;
use std::sync::Arc;
use tokio::sync::broadcast;

#[tokio::main]
async fn main() {
    let ds: Arc<Store> = Arc::new(Store::init());
    let (tx, mut _rx) = broadcast::channel(500);

    // ds.add_mock_node("1.1.1.1".to_string()).await;
    // ds.add_mock_node("1.2.3.4".to_string()).await;
    // ds.add_mock_node("1.2.2.2".to_string()).await;

    let mut join_set = JoinSet::new();

    join_set.spawn(http_server::init(ds.clone()));
    join_set.spawn(grpc::server::MyServer::init(ds.clone(), tx.clone()).start());
    join_set.spawn(grpc::client::init_connections(ds.clone(), tx.clone()));

    // exit no matter which task finished
    join_set.join_next().await;
    println!("Shutting down...");
}
